import 'package:firebase_node/functions.dart';
import 'package:firebase_node/admin.dart' as admin;

void main() {
  functions['onCreateUser'] =
      functions.auth.user().onCreate((user, context) async {
    final app = await admin.initializeApp();
    final ref = app.firestore().collection('userdata').doc(user.uid);
    await ref.set({
      'name': user.displayName,
      'email': user.email,
    });
  });

  functions['onDeleteUser'] = functions.auth.user().onDelete(onDeleteUser);
}

Future<void> onDeleteUser(UserRecord user, EventContext context) async {
  final app = await admin.initializeApp();
  final ref = app.firestore().collection('userdata').doc(user.uid);
  await ref.delete();
}
